// BlinkenSisters - Hunt for the Lost Pixels
//     Bringing back the fun of the 80s
//
// (C) 2005-07 Rene Schickbauer, Wolfgang Dautermann
//
// See License.txt for licensing information
//

#include "bl_lua_obj_player.h"

#define NEED_REGISTER_FUNCTION
#include "bl_lua.h"
#undef NEED_REGISTER_FUNCTION

// Player X coordinates
int luaObjPlayerX(lua_State *L) {
	Uint32 n = lua_gettop(L);
	if(n > 1) {
		LUADIE(ERROR_LUAARGCOUNT, "luaObjPlayerX");
	}
	double x = 0.0;
	if(n == 1) {
		if(!lua_isnumber(L, 1)) {
			LUADIE(ERROR_LUAL2BTYPE, "luaObjPlayerX");
		} else {
			x = (double)lua_tonumber(L, 1);
		}
		spritex = x;
	}
	
	x = spritex;
	lua_pushnumber(L, x);
	
	return 1;
}

// Player Y coordinates
int luaObjPlayerY(lua_State *L) {
	Uint32 n = lua_gettop(L);
	if(n > 1) {
		LUADIE(ERROR_LUAARGCOUNT, "luaObjPlayerY");
	}
	double y = 0.0;
	if(n == 1) {
		if(!lua_isnumber(L, 1)) {
			LUADIE(ERROR_LUAL2BTYPE, "luaObjPlayerY");
		} else {
			y = (double)lua_tonumber(L, 1);
		}
		spritey = y;
	}
	
	y = spritey;
	lua_pushnumber(L, y);
	
	return 1;
}

// Player X speed
int luaObjPlayerVX(lua_State *L) {
	Uint32 n = lua_gettop(L);
	if(n > 1) {
		LUADIE(ERROR_LUAARGCOUNT, "luaObjPlayerVX");
	}
	double x = 0.0;
	if(n == 1) {
		if(!lua_isnumber(L, 1)) {
			LUADIE(ERROR_LUAL2BTYPE, "luaObjPlayerVX");
		} else {
			x = (double)lua_tonumber(L, 1);
		}
		spritevx = x;
	}
	
	x = spritevx;
	lua_pushnumber(L, x);
	
	return 1;
}

// Player Y speed
int luaObjPlayerVY(lua_State *L) {
	Uint32 n = lua_gettop(L);
	if(n > 1) {
		LUADIE(ERROR_LUAARGCOUNT, "luaObjPlayerVY");
	}
	double y = 0.0;
	if(n == 1) {
		if(!lua_isnumber(L, 1)) {
			LUADIE(ERROR_LUAL2BTYPE, "luaObjPlayerVY");
		} else {
			y = (double)lua_tonumber(L, 1);
		}
		spritevy = y;
	}
	
	y = spritevy;
	lua_pushnumber(L, y);
	
	return 1;
}

// Kill a playder (loose a live)
int luaObjKillPlayer(lua_State *L) {
	killPlayer = true;
	
	// Avoid compiler warning about unused argument (because prototype requires it)
	if(!L) {
        return 0;
    }
	
	return 0;
}

// Player Score
int luaObjPlayerScore(lua_State *L) {
	Uint32 n = lua_gettop(L);
	if(n > 1) {
		LUADIE(ERROR_LUAARGCOUNT, "luaObjPlayerScore");
	}
	Uint32 score = 0;
	if(n == 1) {
		if(!lua_isnumber(L, 1)) {
			LUADIE(ERROR_LUAL2BTYPE, "luaObjPlayerScore");
		} else {
			score = (Uint32)lua_tonumber(L, 1);
		}
		gamedata.player->score = score;
	}
	
	score = gamedata.player->score;
	lua_pushnumber(L, score);
	
	return 1;
}

// Player Lives
int luaObjPlayerLives(lua_State *L) {
	Uint32 n = lua_gettop(L);
	if(n > 1) {
		LUADIE(ERROR_LUAARGCOUNT, "luaObjPlayerLives");
	}
	Uint32 lives = 0;
	if(n == 1) {
		if(!lua_isnumber(L, 1)) {
			LUADIE(ERROR_LUAL2BTYPE, "luaObjPlayerLives");
		} else {
			lives = (Uint32)lua_tonumber(L, 1);
		}
		gamedata.player->lives = lives;
	}
	
	lives = gamedata.player->lives;
	lua_pushnumber(L, lives);
	
	return 1;
}
