# FindTheora.cmake from the KDE Multimedia project
#
# if you want to include that file in your own code, you should use the
# original file from the KDE Multimedia project - that will probably be a newer version...
# (http://websvn.kde.org/kde/*checkout*/trunk/KDE/kdemultimedia/cmake/modules/FindTheora.cmake)


# Option for build or not Theora

# Copyright (c) 2006,2007 Laurent Montel, <montel@kde.org>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

# Text from the kdemultimedia COPYING-CMAKE-SCRIPTS file:
# (http://websvn.kde.org/kde/*checkout*/trunk/KDE/kdemultimedia/cmake/modules/COPYING-CMAKE-SCRIPTS)
###########################################################################
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. The name of the author may not be used to endorse or promote products 
#    derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
###########################################################################


#if(THEORA_INCLUDE_DIR AND THEORA_LIB_LIBRARIES AND THEORA_VORBIS_LIBRARIES AND THEORA_OGG_LIBRARIES)
#	# Already in cache, be silent
#	set(Theora_FIND_QUIETLY TRUE)	
#endif(THEORA_INCLUDE_DIR AND THEORA_LIB_LIBRARIES AND THEORA_VORBIS_LIBRARIES AND THEORA_OGG_LIBRARIES)

FIND_PATH(THEORA_INCLUDE_DIR theora/theora.h)

FIND_LIBRARY(THEORA_OGG_LIBRARIES NAMES ogg )

FIND_LIBRARY(THEORA_VORBIS_LIBRARIES NAMES vorbis)

FIND_LIBRARY(THEORA_LIB_LIBRARIES NAMES theora)

if(THEORA_LIB_LIBRARIES AND THEORA_VORBIS_LIBRARIES AND THEORA_OGG_LIBRARIES AND THEORA_INCLUDE_DIR)
	set(THEORA_LIBRARY ${THEORA_LIB_LIBRARIES} ${THEORA_OGG_LIBRARIES} ${THEORA_VORBIS_LIBRARIES})
	set(THEORA_FOUND TRUE)
endif(THEORA_LIB_LIBRARIES AND THEORA_VORBIS_LIBRARIES AND THEORA_OGG_LIBRARIES AND THEORA_INCLUDE_DIR)

if (THEORA_FOUND)
  if (NOT Theora_FIND_QUIETLY)
     MESSAGE( STATUS "theora found: includes in ${THEORA_INCLUDE_DIR}, library in ${THEORA_LIBRARY}")
  endif (NOT Theora_FIND_QUIETLY)
else (THEORA_FOUND)
  if (Theora_FIND_REQUIRED)
     MESSAGE( FATAL_ERROR "theora not found")
  endif (Theora_FIND_REQUIRED)
endif (THEORA_FOUND)


MARK_AS_ADVANCED(THEORA_INCLUDE_DIR THEORA_LIBRARY)
