// BlinkenSisters - Hunt for the Lost Pixels
//     Bringing back the fun of the 80s
//
// (C) 2005-07 Rene Schickbauer, Wolfgang Dautermann
//
// See License.txt for licensing information
//


#include "globals.h"
#include "showloading.h"
#include "memops.h"
#include "errorhandler.h"

SDL_Surface *LOADING_Surface;

void initShowLoading(const char *fname) {
	char fullfname[MAX_FNAME_LENGTH];
	sprintf(fullfname, "%s", configGetPath(fname));
	SDL_Surface* temp = IMG_Load(fullfname);
	if(!temp) {
		DIE(ERROR_IMAGE_READ, fullfname);
	}
	LOADING_Surface = SDL_DisplayFormat(temp);
	SDL_FreeSurface(temp);
}


void showLoading() {
	
	/*
	// Lock Surfaces if needed
	if (SDL_MUSTLOCK(LOADING_Surface))
		if (SDL_LockSurface(LOADING_Surface) < 0) 
			return;
	if (SDL_MUSTLOCK(gScreen))
		if (SDL_LockSurface(gScreen) < 0) 
			return;
	
	Uint32 pitch_tmp = LOADING_Surface->pitch / 4;
	Uint32 pitch_bg = gScreen->pitch / 4;	
	Uint32 i, j;
	
	// Copy the background into the bigger surface
	for(i=0; i < (Uint32)LOADING_Surface->w; i++) {
		for(j=0; j < (Uint32)LOADING_Surface->h; j++) {
			((Uint32 *)gScreen->pixels)[j * pitch_bg + i] = 
			((Uint32 *)LOADING_Surface->pixels)[j * pitch_tmp + i];
		}
	}
	
	// Unlock Surfaces if needed
	if (SDL_MUSTLOCK(gScreen)) 
		SDL_UnlockSurface(gScreen);
	if (SDL_MUSTLOCK(LOADING_Surface)) 
		SDL_UnlockSurface(LOADING_Surface);
	 */
	SDL_Rect src, dest;
	dest.x = dest.y = src.x = src.y = 0;
	src.w = dest.w = SCR_WIDTH;
	src.h = dest.h = SCR_HEIGHT;
	
	SDL_BlitSurface(LOADING_Surface, &src, gScreen, &dest);
	
	// Tell SDL to update the whole screen
	SDL_Flip(gScreen);

}

void deInitShowLoading() {
	SDL_FreeSurface(LOADING_Surface);
}
